/*;  ll2utm.cc {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision$$ {\rhead{\sl ll2utm.cc\quad\thepage}} */
/*;  $$Date$$  */
/*;  $$Source$$  */

// @(#) ٷٺɸ UTM ɸѴ

#include <stdio.h>
#include <math.h>

void ll2utm( // ޷ٺɸ UTM ɸѴ롣
             // ڿ;(ģײ衦ĴɡС
             // ¢ʰȯ), pp. 194--196 򻲹ͤˤ
  double lambda, // ١ñ̤١
  double phi,  // ١ñ̤١
  double *ue,   //  UTM ɸñ̤ m.
  double *un,   //  UTM ɸñ̤ m.
  double cc // оݤȤ UTM Ҹ()η١㤨С
            // UTM  53 Ӥ 132 ٤ 138 ٤ϰϤǤꡢ
            // ξ cc  135 Ȥ롣
)
{
  double pi, lambda0, e2, ed2, a, b, b1, b2, b3,
    l, t2, gamma2, f, f1, f2, A, B, g, g1, g2;

  pi = 4.0*atan(1.0);
  e2 = 0.006674372;  /* ΥΨΣ */
  ed2 = 0.006719219; /* ΥΨΣ */
  a = 6377.397155;   /* ϵʱΤĹȾ(km) */
  b = 6356.078963;   /* ϵʱΤûȾ(km) */
  lambda0 = cc*pi/180.0;    /* ñ̤饸Ѵ */
  lambda = lambda*pi/180.0; /* ñ̤饸Ѵ */
  phi = phi*pi/180.0;       /* ñ̤饸Ѵ */
  A = a/sqrt(1.-e2*pow(sin(phi), 2));
  b1 = 0.998329312962;
  b2 = 0.00501415801;
  b3 = 0.00001049328;
  B = a*(b1*phi-b2*sin(phi)*cos(phi)
     +b3*(sin(phi)*pow(cos(phi), 3)-pow(sin(phi), 3)*cos(phi)));
  l = lambda-lambda0;
  t2 = pow(tan(phi), 2);
  gamma2 = ed2*(pow(cos(phi), 2));
  f1 = 1.0-t2+gamma2;
  f2 = 5.0-18.0*t2+pow(t2, 2)+14.0*gamma2-58.0*t2*gamma2;
  f = A*l*cos(phi)*(1.0+1.0/6.0*pow(l, 2)*pow(cos(phi), 2)
		    *(f1+1.0/20.0*pow(l, 2)*pow(cos(phi), 2)*f2));
  g1 = 5.0-t2+9.0*gamma2+4.0*pow(gamma2, 2);
  g2 = 61.0-58.0*t2+pow(t2, 2)+270.0*gamma2-330.0*t2*gamma2;
  g = B+0.5*A*pow(l, 2)*sin(phi)*cos(phi)
      *(1.0+1.0/12.0*pow(l, 2)*pow(cos(phi), 2)
      *(g1+1.0/30.0*pow(l, 2)*pow(cos(phi), 2)*g2));
  *ue = (0.9996*f+500.0)*1000.0;
  *un = (0.9996*g)*1000.0;
}


int main(void)
{
  double lambda, phi, ue, un, cc;

  printf("٤ñ̤Ϥʤ\n");
  scanf("%lf", &lambda);
  printf("٤ñ̤Ϥʤ\n");
  scanf("%lf", &phi);
  printf("Ӥη٤ϤƤ(ex. 129, 135, 141, ...)\n");
  scanf("%lf", &cc);

  ll2utm(lambda, phi, &ue, &un, cc);

  printf("x = %f : y = %f \n", ue, un);
  return 0;
}

/*; end of file */
